package ru.dbotthepony.mc.otm.datagen

import net.minecraft.resources.ResourceLocation
import net.minecraft.world.level.block.Block
import net.minecraftforge.client.model.generators.BlockModelProvider
import net.minecraftforge.eventbus.api.SubscribeEvent
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.forge.event.lifecycle.GatherDataEvent
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.Registry
import ru.dbotthepony.mc.otm.datagen.blocks.BatteryBankProvider
import ru.dbotthepony.mc.otm.datagen.blocks.MatterBankProvider
import ru.dbotthepony.mc.otm.datagen.blocks.SimpleBlockProvider
import ru.dbotthepony.mc.otm.datagen.blocks.SimpleBlockStateProvider

@Mod.EventBusSubscriber(modid = DataGen.MOD_ID, bus = Mod.EventBusSubscriber.Bus.MOD)
object DataGen {
	const val MOD_ID = OverdriveThatMatters.MOD_ID

	private lateinit var blockModelProvider: SimpleBlockProvider
	private lateinit var blockStateProvider: SimpleBlockStateProvider

	private fun decorativeCubeAll(vararg blocks: Block) {
		blockModelProvider.decorativeCubeAll(*blocks)
		blockStateProvider.addBlock(*blocks)
	}

	@SubscribeEvent
	@JvmStatic
	@Suppress("unused")
	fun onGatherData(event: GatherDataEvent) {
		blockModelProvider = SimpleBlockProvider(event)
		blockStateProvider = SimpleBlockStateProvider(event)

		event.generator.addProvider(blockModelProvider)
		event.generator.addProvider(blockStateProvider)

		decorativeCubeAll(*Registry.Blocks.CRATES)
		decorativeCubeAll(Registry.Blocks.CARBON_FIBRE_BLOCK)
		decorativeCubeAll(Registry.Blocks.TRITANIUM_BLOCK)
		decorativeCubeAll(Registry.Blocks.TRITANIUM_STRIPED_BLOCK)

		blockStateProvider.addBlock(Registry.Blocks.BLACK_HOLE)

		event.generator.addProvider(MatterBankProvider(event))
		event.generator.addProvider(BatteryBankProvider(event))
	}
}
