package ru.dbotthepony.mc.otm.datagen.blocks

import net.minecraft.resources.ResourceLocation
import net.minecraft.world.level.block.Block
import net.minecraftforge.client.model.generators.BlockModelProvider
import net.minecraftforge.forge.event.lifecycle.GatherDataEvent
import ru.dbotthepony.mc.otm.datagen.DataGen

private data class CubeAllEntry(val path: String, val texture: ResourceLocation)

class SimpleBlockProvider(event: GatherDataEvent) : BlockModelProvider(event.generator, DataGen.MOD_ID, event.existingFileHelper) {
	private val cubeAll = ArrayList<CubeAllEntry>()

	override fun registerModels() {
		for ((path, texture) in cubeAll) {
			cubeAll(path, texture)
		}
	}

	fun decorativeCubeAll(vararg blocks: Block) {
		for (it in blocks) {
			cubeAll.add(CubeAllEntry(it.registryName!!.path, ResourceLocation("overdrive_that_matters:block/decorative/${it.registryName!!.path}")))
		}
	}
}
