package ru.dbotthepony.mc.otm.datagen.blocks

import net.minecraft.resources.ResourceLocation
import net.minecraft.world.level.block.Block
import net.minecraftforge.client.model.generators.BlockStateProvider
import net.minecraftforge.client.model.generators.ConfiguredModel
import net.minecraftforge.forge.event.lifecycle.GatherDataEvent
import ru.dbotthepony.mc.otm.datagen.DataGen

class SimpleBlockStateProvider(event: GatherDataEvent) : BlockStateProvider(event.generator, DataGen.MOD_ID, event.existingFileHelper) {
	private val blocks = ArrayList<Block>()

	fun addBlock(vararg block: Block) {
		blocks.addAll(block)
	}

	override fun registerStatesAndModels() {
		for (block in blocks) {
			getVariantBuilder(block).forAllStates {
				check(block.registryName != null) {"$block registry name is null!"}
				return@forAllStates arrayOf(ConfiguredModel(models().getExistingFile(block.registryName)))
			}
		}
	}
}
